%% Unification framework for types.
%%
%% Copyright (C) 2005-2006, Babel Group
%%
%% Written by: 
%%   * Emilio Jesús Gallego Arias
%%
%% This program is free software; you can redistribute it and/or
%% modify it under the terms of the GNU General Public License
%% as published by the Free Software Foundation; either version 2
%% of the License, or (at your option) any later version.
%%
%% This program is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%% GNU General Public License for more details.
%%
%% You should have received a copy of the GNU General Public License
%% along with this program; if not, write to the Free Software
%% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

:- module(types_unify, [unify_types/2]).

unify_types(A, B) :-
	unify_with_occurs_check(A, B),
	!.

%% The copy_term is needed in order to not segfault when printing.
unify_types(A, B) :-
	copy_term(A, A1),
	A = B,
	throw(error(typer, infinite_type(A1))).
	    
unify_types(A, B) :-
	throw(error(typer, could_not_unify(A, B))).
