module Matrix where

import IO

-- Función de utilidad.
cartesian :: (a -> b -> c) -> [a] -> [b] -> [c]
cartesian f l1 l2 = 
    foldr (\x1 cart -> (map (\x2 -> f x1 x2) l2) ++ cart) [] l1

-- Transposición de una matriz
transpose :: [[a]] -> [[a]]
transpose (x:xs) = 
    if xs == [] then
        map (\e -> [e]) x
    else
        map (\(e,ex) -> (e:ex)) (zip x (transpose xs))

-- Multiplicación (ineficiente) de matrices
--matMult :: [[a]] -> [[a]] -> [[a]]
matMult m1 m2 = let m2t = transpose m2 
                    tup = zipWith mkTuple m1 m2t
                    ct  = cartesian mkTuple tup tup
--                    mr1 = map (cartesian mkTuple m1l m2l
--                    r1  = map (\(t1, t2) -> zipWith (*) t1 t2) mr1
--                    r2  = map (foldl (+) 0) r1
                     in ct
--                    r2  = map (map (foldr (+) 0)) r1 
--                    r1  = map (map (\(f,c) -> zipWith (*) f c)) mr1 

m1 :: [[Int]]
m1 = [[1,2],[3,4]]

m2 :: [[Int]]
m2 = [[1,2,3,4],[5,6,7,8],[9,10,11,12],[13,14,15,16]]

-- main = printLn $ matMult m2 m2
